var SUNMI_ENV = process.env.SUNMI_ENV || process.env.SUNMI_DEFAULTHOST;
// 是否加密
var isEncrypted, envHost, md5Key, DES;
switch (SUNMI_ENV) {
    case 'dev':
    case 'test':
        isEncrypted = 0;
        envHost = function (host) { return host.replace('sunmi.com', SUNMI_ENV + ".sunmi.com"); };
        md5Key = process.env.SUNMI_DEVELOPMENT_MD5KEY;
        DES = {
            Iv: process.env.SUNMI_DEVELOPMENT_DESIV,
            Key: process.env.SUNMI_DEVELOPMENT_DESKEY
        };
        break;
    case 'uat':
        isEncrypted = 1;
        envHost = function (host) { return host.replace('sunmi.com', SUNMI_ENV + ".sunmi.com"); };
        md5Key = process.env.SUNMI_PRODUCTION_MD5KEY;
        DES = {
            Iv: process.env.SUNMI_PRODUCTION_DESIV,
            Key: process.env.SUNMI_PRODUCTION_DESKEY
        };
        break;
    case 'pub':
    default:
        isEncrypted = 1;
        envHost = function (host) { return "" + host; };
        md5Key = process.env.SUNMI_PRODUCTION_MD5KEY;
        DES = {
            Iv: process.env.SUNMI_PRODUCTION_DESIV,
            Key: process.env.SUNMI_PRODUCTION_DESKEY
        };
        break;
}
export { envHost, isEncrypted, md5Key, DES };
