var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import encodeURL from '../secure/encodeURL';
import Cookie from '../storages/Cookie';
import resolveURL from './resolveURL';
import resolveParams from './resolveParams';
import _ from 'lodash';
import { browserHistory } from 'react-router';
import fetch from 'isomorphic-fetch';
/**
 * 获取API的函数
 * @param  {string} api  'app/api'定义的接口
 * @param  {Object} opts fetch的option
 * @param  {bool}   unuseJson 返回未json格式化的数据
 * @return {Promise}
 */
export default function fetchBy(api, opts) {
    return __awaiter(this, void 0, void 0, function () {
        var method, body, url, formData, myFormData, options, json, error_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    method = opts.method, body = opts.body;
                    return [4 /*yield*/, resolveURL(api)];
                case 1:
                    url = _a.sent();
                    formData = resolveParams(body);
                    myFormData = new FormData();
                    _.forEach(formData, function (value, key) { myFormData.append(key, value); });
                    options = __assign({}, opts, { method: method, body: myFormData });
                    if (!formData || method === 'GET' || method === 'HEAD') {
                        delete options.body;
                    }
                    _a.label = 2;
                case 2:
                    _a.trys.push([2, 4, , 5]);
                    return [4 /*yield*/, fetch(url, options).then(function (res) { return res.json(); })];
                case 3:
                    json = _a.sent();
                    if (json.code === -2) {
                        sessionStorage.clear();
                        Cookie.removeItem(encodeURL('dId'), '/');
                        Cookie.removeItem(encodeURL('userBase'), '/');
                        Cookie.removeItem(encodeURL('userName'), '/');
                        Cookie.removeItem(encodeURL('userData'), '/');
                        Cookie.removeItem(encodeURL('passWord'), '/');
                        browserHistory.replace('/login');
                        window.location.reload();
                        return [2 /*return*/, json];
                    }
                    if (json.code !== 1) {
                        // alert(`异常:${JSON.stringify(json)}`);
                        throw json;
                    }
                    return [2 /*return*/, json];
                case 4:
                    error_1 = _a.sent();
                    throw error_1;
                case 5: return [2 /*return*/];
            }
        });
    });
}
