import Des from '../secure/Des';
import md5 from 'md5';
// @ts-ignore
import { isEncrypted, md5Key } from '../../env'; // tslint:disable-line
export function signEncode(form) {
    if (!md5Key) {
        throw new Error('请检查config配置文件！no md5Key');
    }
    var key = md5Key;
    var params = form.params, timeStamp = form.timeStamp, randomNum = form.randomNum;
    return md5(params + isEncrypted + timeStamp + randomNum + md5(key));
}
export function paramsEncode(params) {
    var paramsString = JSON.stringify(params);
    if (isEncrypted) {
        return Des.encrypt(paramsString);
    }
    else {
        return paramsString;
    }
}
export default function resolveParams(params) {
    var formData = {};
    formData.timeStamp = Math.floor(new Date().getTime() / 1000);
    formData.randomNum = Math.floor(Math.random() * 1000000);
    formData.isEncrypted = isEncrypted;
    if (!params) {
        formData.params = '';
    }
    else {
        if (params.file) {
            formData.file = params.file;
            delete params.file;
        }
        formData.params = paramsEncode(params);
    }
    formData.sign = signEncode(formData);
    formData.lang = 'zh';
    return formData;
}
