import _ from 'lodash';
export function createRoutes(routes) {
    _.forEach(routes, function (value, key) {
        if (key === 'childRoutes') {
            routes.getChildRoutes = childRoutesUtil(value);
            delete routes.childRoutes;
        }
        if (key === 'component') {
            routes.getComponents = componentsUtil(value);
            delete routes.component;
        }
        if (key === 'indexRoute') {
            routes.getIndexRoute = indexRouteUtil(value);
            delete routes.indexRoute;
        }
    });
    return routes;
}
export function childRoutesUtil(arr) {
    return function (next, cb) {
        cb(null, arr.map(function (item) {
            if (item.childRoutes) {
                item.getChildRoutes = childRoutesUtil(item.childRoutes);
                delete item.childRoutes;
            }
            if (item.component) {
                item.getComponents = componentsUtil(item.component);
                delete item.component;
            }
            if (item.indexRoute) {
                item.getIndexRoute = indexRouteUtil(item.indexRoute);
                delete item.indexRoute;
            }
            return item;
        }));
    };
}
export function indexRouteUtil(per) {
    return function (next, cb) {
        if (per.component) {
            per.getComponents = componentsUtil(per.component);
            delete per.component;
        }
        cb(null, per);
    };
}
export function componentsUtil(per) {
    return function (next, cb) {
        if (per) {
            per.then(function (route) {
                cb(null, route.default);
            });
        }
    };
}
